﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DragDrop
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        public MainWindow()
        {
            InitializeComponent();
        }

        private void Label_MouseMove(object sender, MouseEventArgs e)
        {
            base.OnMouseMove(e);
            if (e.LeftButton == MouseButtonState.Pressed)
            {
                // Luodaan raahauksen mukana kuskattava data
                // esimerkin vuoksi useita erilaisia muotoja
                // yleensä kaikki muodot sisältävät saman datan esim. kuvasta voisi olla
                // eri muotoja mutta tässä datana on mitä sattuu
                DataObject data = new DataObject();
                // Omadata, Double ja Label ovat ihan mitä tahansa itsekeksittyjä tunnisteita
                // jos halutaan, että raahattava data toimii muissakin ohjelmissa niin on
                // käytettävä DataFormatsin sisältämiä vaihtoehtoja
                data.SetData("OmaData", 10);
                data.SetData(DataFormats.StringFormat, "merkkijono");
                data.SetData("Double", 5.5);
                data.SetData("Label", sender);

                // Aloitetaan raahaus
                System.Windows.DragDrop.DoDragDrop(this, data, DragDropEffects.Copy | DragDropEffects.Move);
            }
        }

        private void Label_Drop(object sender, DragEventArgs e)
        {
            base.OnDrop(e);

            // Löytyykö oma data
            if (e.Data.GetDataPresent("OmaData"))
            {
                int luku = (int)e.Data.GetData("OmaData");
                MessageBox.Show(luku.ToString());

            }
            if (e.Data.GetDataPresent(DataFormats.StringFormat))
            {
                 MessageBox.Show( (string)e.Data.GetData(DataFormats.StringFormat));

            }
            if (e.Data.GetDataPresent("Double"))
            {
                double luku = (double)e.Data.GetData("Double");
                MessageBox.Show(luku.ToString());

            }
            if (e.Data.GetDataPresent("Label"))
            {
                Label apu = (Label)e.Data.GetData("Label");
                MessageBox.Show(apu.Content.ToString());

            }
            e.Handled = true;
        }
    }
}
